public class Main {

	public static void main(String[] args) {

		// String text = "CCCTAAACCCCC";
		// String text = "1011010110110";

		// FindRepetition find_repetition = new FindRepetition();
		// RepetitionList repetition_list = new RepetitionList();

		// MakeHistogram make_histo = new MakeHistogram("test.fastq");
		// make_histo.output();

		if (args.length == 0) {
			System.out.println("no inputfile!!");
			return;
		} else {

			MakeHistogram make_histo = new MakeHistogram();
			
			int filetype = 1;
			int approx = 1;
			int paired = 1;
			int debug = 1;
			String output_histogram = "histogram.list";
			String output_fasta = "paired.fasta";
			String output_repeatlist = "repeat.list";
			
			for (int i=0; i<args.length; ++i) {
				if ("-z".equals(args[i])){
					filetype = 2;
				} else if("-a".equals(args[i])){
					approx = 2;
				} else if("-p".equals(args[i])){
					paired = 2;
				} else if("-d".equals(args[i])){
					debug = 2;
				} else if("-output".equals(args[i])){
					output_histogram = args[++i];
				} else if("-output_debug".equals(args[i])){
					output_repeatlist = args[++i];
				} else if("-output_fasta".equals(args[i])){
					output_fasta = args[++i];
				}
			}
			
			if(paired == 1) {
				make_histo.make_histogram(args[args.length-1], filetype, approx, output_histogram, debug, output_repeatlist, paired, "", output_fasta);
			}else {
				make_histo.make_histogram(args[args.length-2], filetype, approx, output_histogram, debug, output_repeatlist, paired, args[args.length-1], output_fasta);
			}
//				make_histo.make_histogram_pairedend(args[args.length-2], args[args.length-1], filetype, approx, output_fasta, debug);
			//}
			//if (args[0].compareTo("-z") == 0) {
			//	make_histo.make_histogram_gzip(args[1], 2);
			//} else {
			//	make_histo.make_histogram_gzip(args[0], 1);
			//}
		}

//		 MakeHistogram make_histo = new MakeHistogram();
//		
//		 make_histo.make_histogram_fastq("test.fastq");
//		 make_histo.make_histogram_gzip("test.fastq.gz");

	}

}
